/*
 * pwgen without arguments generates a 8 char random password
 * pwgen with arguments encrypts the argument with the crypt() function
 * prints the result on stdout
 * This is -NOT- a real secure way to either generate nonguessable passwords
 * nor is the invocation of crypt very secure (only uses [A-Z][A-Z] for the
 * salt).
 * but it's enough to do what i want to do with it ;)
 * <x@4t2.com>
 */

#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <stdio.h>

int main (int argc, char *argv[]) {
    char pw[9];
    int i;

    srand((unsigned int)time(NULL));
    if (argc == 1) {
        for (i=0; i<8; i++) {
            if (rand()%2)   pw[i] = 'A'+(int)(57.0 * rand()/(RAND_MAX+1.0));
            else            pw[i] = '0'+(10.0 * rand()/(RAND_MAX+1.0));
        }
        pw[8] = '\0';
        puts(pw);
        return (0);
    } else if (argc == 2) {
        pw[0] = 'A'+(int)(25.0 * rand()/(RAND_MAX+1.0));
        pw[1] = 'A'+(int)(25.0 * rand()/(RAND_MAX+1.0));
        pw[2] = '\0';
        puts((char*)crypt(argv[1], pw));
    }
    return(-1);
}
