%set_verify_elf_method unresolved=relaxed
%define ugname caudium
%define pike_ver 7.6.112

Summary: Caudium - modern, fast and extensible WWW server
Name: caudium
Version: 1.4.8
Release: alt3.qa1
License: GPL
Group: System/Servers
Source: ftp://ftp.caudium.net/caudium/source/%name-%version.tar.gz
Source1: caudium.init
Source2: caudium.Global_Variables
Source3: caudium.default_server
Source4: caudium.pwgen.c
Source5: caudium.logrotate
Patch: %name-all-in-one.patch
Url: http://caudium.net/
Packager: Boris Savelev <boris@altlinux.org>
Requires: pike7.6
Provides: webserver

# Automatically added by buildreq on Thu May 14 2009
BuildRequires: java libexpat-devel libpcre-devel libsablotron-devel
BuildRequires: pike7.6-GL pike7.6-GLUT pike7.6-bzip2 pike7.6-devel
BuildRequires: pike7.6-gdbm pike7.6-gtk pike7.6-image pike7.6-java
BuildRequires: pike7.6-mysql pike7.6-nettle pike7.6-odbc pike7.6-perl
BuildRequires: pike7.6-postgres pike7.6-sane pike7.6-sdl pike7.6-zlib
BuildRequires: unixODBC rpm-macros-webserver-common

%description
Caudium is the name of a GPL webserver written in the interpreting language
Pike  as well as in C. It is originally based on the Roxen Challenger 1.3 code
base. It is an attractive alternative to servers like Apache, Netscape and
Zeus due to it's strength in dynamic page and data generation, modularity and
more.

%package pixsl
Summary: Caudium PiXSL Pike XSLT module
License: GPL
Group: System/Servers
Requires: %name = %version-%release

%description pixsl
Certain parts of Caudium are coded in C for speed. This package contains
the compiled shared extension module that provides Caudium with XSLT support.

%package pcre
Summary: Caudium PCRE module
License: GPL
Group: System/Servers
Requires: %name = %version-%release

%description pcre
Certain parts of Caudium are coded in C for speed. This package contains
the compiled shared extension module that provides Caudium with PCRE support.

%package mhash
Summary: Caudium Mhash module
License: GPL
Group: System/Servers
Requires: %name = %version-%release

%description mhash
Certain parts of Caudium are coded in C for speed. This package contains
the compiled shared extension module that provides Caudium with Mhash support.

%package ultralog
Summary: Caudium Ultralog log parser module
License: GPL
Group: System/Servers
Requires: %name = %version-%release

%description ultralog
Certain parts of Caudium are coded in C for speed. This package contains
the compiled shared extension module that provides Caudium with a built-in.
log file parser that is capable of generating extensive statistics on the.
fly for virtual servers configured in your Caudium WebServer.

%package perl
Summary: Caudium perl module
License: GPL
Group: System/Servers
Requires: %name = %version-%release

%description perl
Certain parts of Caudium are coded in C for speed. This package contains
the compiled shared extension module that provides Caudium with perl support.

%package devel
Summary: Caudium devel
License: GPL
Group: System/Servers
Requires: %name = %version-%release

%description devel
Certain parts of Caudium are coded in C for speed. This package contains
the devel caudium files

%package conf
Summary: set of configuration files for Caudium
Group: System/Servers
Requires: %name = %version-%release
Requires: net-tools
Requires: sed

%description conf
Set of configuration files for Caudium to run as an Apache replacement on
RedHat Linux systems so that no further install steps are needed.

%prep
%setup
%patch0 -p2

find . -type f | xargs subst "s|/lib/|/%_lib/|g"

%build
export CPPFLAGS="-I%_includedir/pcre"
%configure \
	--with-pike=%_bindir/pike7.6 \
	--with-serverdir=%_libdir/%name
%make_build

cc $RPM_OPT_FLAGS -o pwgen %SOURCE4 -lcrypt

%install
%make_install install_alt DESTDIR=%buildroot prefix=%prefix

%__subst 's;/usr/caudium/server;%_libdir/caudium;g' %buildroot%_bindir/ultrasum

for s in `find %buildroot%_libdir/caudium -name *.pike` ; do
  subst 's;^#\!.*;#\!%_bindir/pike;' ${s}
done

mv %buildroot%_bindir/htpasswd %buildroot%_bindir/htpasswd-caudium

# add libroxen modules path
# change the state directory
sed	-e 's;\(^.*globvar("ModuleDirs".*,({\)\(".*"\)\(}),\);\1\2,"%_datadir/roxen/modules/"\3;' \
	-e 's;\(^.*globvar("font_dirs".*,({\)\(".*"\)\(}),\);\1\2,"local_fonts/",\3;' \
	-e 's;\(^.*globvar("ConfigurationStateDir".*,\)\(".*"\)\([ ]*,.*,\);\1"/var/state/caudium/"\3;' \
	-e 's;\(^.*globvar("User"[ ]*,[ ]*\)\(""\)\(.*,\);\1"33:33"\3;' \
	%buildroot%_libdir/caudium/base_server/caudium.pike

# some link fixes
ln -sf ../../../bin/pike %buildroot%_libdir/caudium/bin/caudium
cp -dp %buildroot%_libdir/caudium/bin/caudium %buildroot%_libdir/caudium/bin/pike

# the cache dirs
mkdir -p %buildroot/var/cache/caudium/caudium-images
cp -rv %buildroot%_libdir/caudium/caudium-images/auto \
	%buildroot/var/cache/caudium/caudium-images
rm -fr %buildroot%_libdir/caudium/caudium-images/auto
ln -s /var/cache/caudium/caudium-images/auto %buildroot%_libdir/caudium/caudium-images/auto

mkdir -p %buildroot/var/cache/caudium/argument_cache
mkdir -p %buildroot/var/cache/caudium/cache
mkdir -p %buildroot/var/cache/caudium/storage
mkdir -p %buildroot/var/lib/caudium

# install ultrasum manpage
install -m 644 src/cmods/UltraLog/docs/ultrasum.1 %buildroot/%_man1dir/

mkdir -p %buildroot%_docdir/%name-%version
mv %buildroot%_docdir/%name/* %buildroot%_docdir/%name-%version

mkdir -p %buildroot%_var/log/%name/ultralog

# generate %_sysconfdir/default/caudium
mkdir -p %buildroot%_sysconfdir/default
cat <<EOF > %buildroot%_sysconfdir/default/caudium
#
# This variable will be joined with the default
# Caudium startup options in the init script
#
# This file has been generated automatically the first
# time Caudium was installed on this machine. You can
# modify the START_OPTIONS variable below at your will
# as this file won't ever be modified by the Caudium
# package.
#
# For available options type
# %_libdir/caudium/start-caudium --help
#
START_OPTIONS="$START_OPTIONS"

#
# Stuff for caudiumctl(1)
#
caudiumhome=%_libdir/caudium
pidfile=/var/run/caudium/caudium.pid
killallwww=no
wwwuser=%ugname
flags="$START_OPTIONS"
configdir=%_sysconfdir/%name/servers/
logdir=%_var/log/%name
EOF

#
# the caudium init script
XD=%buildroot%_initdir; test -d $XD || mkdir -p $XD
install -m 755 %SOURCE1 %buildroot%_initdir/caudium
#
# the logrotate stuff
XD=%buildroot%_sysconfdir/logrotate.d; test -d $XD || mkdir -p $XD
install -m 644 %SOURCE5 %buildroot%_sysconfdir/logrotate.d/caudium
#
# the configuration
XD=%buildroot%_sysconfdir/caudium; test -d $XD || mkdir -p $XD $XD/servers
install -m 640 %SOURCE2 $XD/servers/Global_Variables
install -m 640 %SOURCE3 $XD/servers/default_server
#
# the pid file
XD=%buildroot/var/run/caudium; test -d $XD || mkdir -p $XD
#
# some cleanup and prepare for packaging
# get rid of the CVS remains
find %buildroot -type d -name CVS | xargs rm -fr
find %buildroot -type f -name .cvsignore | xargs rm -f
#
# install the pwgen utility
install --strip pwgen %buildroot%_libdir/caudium/bin/

cp -pad server/perl/ %buildroot%_libdir/caudium
sed -i -e 's;^#\!.*;#\!/usr/bin/perl;' %buildroot%_libdir/caudium/perl/bin/perlhelper
chmod 755 %buildroot%_libdir/caudium/perl/bin/perlhelper

%pre
%_sbindir/groupadd -r -f %ugname 2>/dev/null ||:
%_sbindir/useradd -c Caudium -g %ugname -d %_sysconfdir/caudium -s '/dev/null/' \
	-r -G %webserver_group %ugname 2> /dev/null ||:
if LANG=C %_bindir/id %ugname 2>/dev/null | \
		grep -qv "groups=[^[:space:]]*(%webserver_group)"; then
	echo 'Warning: User %ugname is not included in the group %webserver_group!'
	echo '     Add user %ugname to group %webserver_group.'
	%_bindir/gpasswd -M %ugname %webserver_group
fi

%post conf
Ca_UID=`id -u %ugname`
Ca_GID=`id -g %ugname`
Ca_PW=`%_libdir/caudium/bin/pwgen`
Ca_PWe=`%_libdir/caudium/bin/pwgen $Ca_PW`
Ca_HN=`hostname --long`
Ca_DM=`hostname --domain`
PWFILE=%_sysconfdir/caudium/.pw
test -e $PWFILE && rm -f $PWFILE
touch $PWFILE
chmod 600 $PWFILE
echo $Ca_PW >> $PWFILE
touch -t 197001010000 $PWFILE
sed -i -e 's/@Caudium_UID@/'$Ca_UID'/' \
 -e 's/@Caudium_GID@/'$Ca_GID'/'   \
 -e 's/@Caudium_PWe@/'$Ca_PWe'/'   \
 -e 's/@Caudium_HOSTNAME@/'$Ca_HN'/' %_sysconfdir/caudium/servers/Global_Variables
sed -i -e 's/@Caudium_DOMAIN@/'$Ca_DM'/' \
 -e 's/@Caudium_HOSTNAME@/'$Ca_HN'/' %_sysconfdir/caudium/servers/default_server

%files
%_bindir/htpasswd-%name
%_bindir/%{name}ctl
# %_libdir/caudium/bin/garbagecollector.pike
%dir %_libdir/caudium
%dir %_libdir/caudium/bin
%dir %_libdir/caudium/%_lib
%dir %_libdir/caudium/%_lib/%pike_ver
%_libdir/caudium/bin/install.pike
%_libdir/caudium/bin/pdbi.pike
%_libdir/caudium/bin/sqladduser.pike
%_libdir/caudium/bin/caudium
%_libdir/caudium/bin/pwgen
%_libdir/caudium/base_server
%_libdir/caudium/caudium-images
%_libdir/caudium/config_actions
%_libdir/caudium/etc
%exclude %_libdir/caudium%_sysconfdir/modules/UltraSupport.pmod
%_libdir/caudium/fonts
%_libdir/caudium/nfonts
%_libdir/caudium/protocols
%_libdir/caudium/languages
%_libdir/caudium/server_templates
%_libdir/caudium/configvar
%_libdir/caudium/demo_certificate.pem
%_libdir/caudium/install
%_libdir/caudium/mkdir
%_libdir/caudium/start-caudium
%_libdir/caudium/testca.pem
%_libdir/caudium/modules/auth
%_libdir/caudium/modules/directories
%_libdir/caudium/modules/filesystems
%_libdir/caudium/modules/graphics
%_libdir/caudium/modules/logging
%_libdir/caudium/modules/proxies
%_libdir/caudium/modules/tags
%_libdir/caudium/modules/examples
%_libdir/caudium/modules/error
%_libdir/caudium/modules/filters
%_libdir/caudium/modules/ldap
%_libdir/caudium/modules/misc
%_libdir/caudium/modules/vhs
%_libdir/caudium/modules/scripting
%exclude %_libdir/caudium/modules/scripting/perl.pike
%dir %_libdir/caudium/modules
%dir /var/log/caudium
%attr(2770,root,%ugname) %dir /var/lib/caudium
%attr(2770,root,%ugname) %dir /var/run/caudium
%attr(2770,root,%ugname) %dir /var/cache/caudium
%attr(2770,root,%ugname) %dir /var/cache/caudium/storage
%attr(2770,root,%ugname) %dir /var/cache/caudium/cache
%attr(2770,root,%ugname) %dir /var/cache/caudium/argument_cache
%attr(2770,root,%ugname) %dir /var/cache/caudium/caudium-images
%attr(2770,root,%ugname) %dir /var/cache/caudium/caudium-images/auto
%dir %attr(2770,root,%ugname) %_sysconfdir/%name
%dir %attr(2770,root,%ugname) %_sysconfdir/%name/servers
%_initdir/caudium
%config %_sysconfdir/default/%name
%config %_sysconfdir/logrotate.d/%name
%_docdir/%name-%version/*
%_man1dir/htpasswd*
%_man1dir/%{name}*
%_libdir/caudium/%_lib/%pike_ver/_Caudium.so
# The package does not own its own docdir subdirectory.
# The line below is added by repocop to fix this bug in a straightforward way. 
# Another way is to rewrite the spec to use relative doc paths.
%dir %_docdir/caudium-%version 

%files mhash
%_libdir/caudium/%_lib/%pike_ver/Mhash.so

%files pcre
%_libdir/caudium/%_lib/%pike_ver/PCRE.so

%files pixsl
%_bindir/pixsl
%_libdir/caudium/bin/pixsl.pike
%_libdir/caudium/%_lib/%pike_ver/PiXSL.so
%_man1dir/pixsl*

%files ultralog
%_bindir/ultrasum
%_libdir/caudium/%_lib/%pike_ver/UltraLog.so
%_libdir/caudium%_sysconfdir/modules/UltraSupport.pmod
%_libdir/caudium/bin/ultrasum.pike
%_libdir/caudium/modules/ultralog/*
%dir %_libdir/caudium/modules/ultralog
%dir /var/log/caudium/ultralog
%_man1dir/ultrasum*

%files perl
%_libdir/caudium/perl/lib
%_libdir/caudium/perl/bin
%_libdir/caudium/modules/scripting/perl.pike

%files devel
%_libdir/caudium/bin/pike

%files conf
%config %attr(0640,root,%ugname) %_sysconfdir/%name/servers/default_server
%config %attr(0640,root,%ugname) %_sysconfdir/%name/servers/Global_Variables

%changelog
* Sat Nov 14 2009 Repocop Q. A. Robot <repocop@altlinux.org> 1.4.8-alt3.qa1
- NMU (by repocop): the following fixes applied:
  * docdir-is-not-owned for caudium
  * postclean-05-filetriggers for spec file

* Sat May 16 2009 Boris Savelev <boris@altlinux.org> 1.4.8-alt3
- add devel subpackage

* Fri May 15 2009 Boris Savelev <boris@altlinux.org> 1.4.8-alt2
- add perl subpackage
- fix directory owner

* Sun Feb 15 2009 Boris Savelev <boris@altlinux.org> 1.4.8-alt1
- initial build for Sisyphus
